import os, pygame
from pygame.locals import *

#functions to create our resources
def load_image(name, colorkey=None):
    fullname = os.path.join('Data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

def load_sound(name):
    class NoneSound:
        def play(self): pass
    if not pygame.mixer or not pygame.mixer.get_init():
        return NoneSound()
    fullname = os.path.join('Music', name)
    try:
        sound = pygame.mixer.Sound(fullname)
    except pygame.error, message:
        print 'Cannot load sound:', fullname
        raise SystemExit, message
    return sound

class Teleporter(pygame.sprite.Sprite):
    """ Teleports our ninja hero """
    def __init__(self, xy, ab, warpChar, floor):
        pygame.sprite.Sprite.__init__(self)
        self.image, self.rect = load_image('gate1.gif', -1)
        self.warpSound = load_sound('warpNoise.wav')
        self.rect.inflate_ip(-10,0)
        font = pygame.font.Font(None, 18)
        text = font.render(warpChar, 1, (0, 0, 0))
        self.image.blit(text, (22,38))
        self.rect.topleft = xy
        self.teleport2 = ab
        self.floor = floor

    def teleportTo(self):
        self.warpSound.play()
        return self.teleport2
